//
// ********************************************************************
// * DISCLAIMER                                                       *
// *                                                                  *
// * The following disclaimer summarizes all the specific disclaimers *
// * of contributors to this software. The specific disclaimers,which *
// * govern, are listed with their locations in:                      *
// *   http://cern.ch/geant4/license                                  *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.                                                             *
// *                                                                  *
// * This  code  implementation is the  intellectual property  of the *
// * GEANT4 collaboration.                                            *
// * By copying,  distributing  or modifying the Program (or any work *
// * based  on  the Program)  you indicate  your  acceptance of  this *
// * statement, and all its terms.                                    *
// ********************************************************************
//
//
// $Id: ExN03SteppingAction.hh,v 1.2 2006/07/11 08:26:05 mackepr Exp $
// GEANT4 tag $Name:  $
//
// 

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#ifndef ExN03SteppingAction_h
#define ExN03SteppingAction_h 1

#include "G4UserSteppingAction.hh"
#include "HistoHelper.hh"

class ExN03DetectorConstruction;
class ExN03EventAction;
class TProfile;
class TH1D;
class TH2D;


//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

class ExN03SteppingAction : public G4UserSteppingAction
{
  public:
    ExN03SteppingAction(ExN03DetectorConstruction*, ExN03EventAction*);
   ~ExN03SteppingAction();

    void UserSteppingAction(const G4Step*);
    
  private:
    ExN03DetectorConstruction* detector;
    ExN03EventAction*          eventaction;  
  HistoHelper* theHistoHelper;

  TProfile* h_mfp;

  TProfile* h_dedx;
  TH2D* h_dedx_scat;
  TProfile* h_dedx_e;
  TH2D* h_dedx_scat_e;
  TProfile* h_dedx_v;
  TH2D* h_dedx_scat_v;
  TH1D* h_dx;
  

};

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#endif
