//
// ********************************************************************
// * DISCLAIMER                                                       *
// *                                                                  *
// * The following disclaimer summarizes all the specific disclaimers *
// * of contributors to this software. The specific disclaimers,which *
// * govern, are listed with their locations in:                      *
// *   http://cern.ch/geant4/license                                  *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.                                                             *
// *                                                                  *
// * This  code  implementation is the  intellectual property  of the *
// * GEANT4 collaboration.                                            *
// * By copying,  distributing  or modifying the Program (or any work *
// * based  on  the Program)  you indicate  your  acceptance of  this *
// * statement, and all its terms.                                    *
// ********************************************************************
//
//
// $Id: ExN03SteppingAction.cc,v 1.5 2006/07/11 08:26:06 mackepr Exp $
// GEANT4 tag $Name:  $
//
// 

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

#include "ExN03SteppingAction.hh"

#include "ExN03DetectorConstruction.hh"
#include "ExN03EventAction.hh"
#include "CustomParticle.h"
#include "G4Track.hh"

////#include "G4RunManager.hh"

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

ExN03SteppingAction::ExN03SteppingAction(ExN03DetectorConstruction* det,
                                         ExN03EventAction* evt)
  :detector(det), eventaction(evt)					 
{
  /*
  theHistoHelper = HistoHelper::GetInstance();

  h_mfp = static_cast<TProfile*>((*theHistoHelper->histolist())[3]);

  h_dedx = static_cast<TProfile*>((*theHistoHelper->histolist())[40]);
  h_dedx_scat = static_cast<TH2D*>((*theHistoHelper->histolist())[41]);
  h_dedx_e = static_cast<TProfile*>((*theHistoHelper->histolist())[49]);
  h_dedx_scat_e = static_cast<TH2D*>((*theHistoHelper->histolist())[50]);
  h_dedx_v = static_cast<TProfile*>((*theHistoHelper->histolist())[51]);
  h_dedx_scat_v = static_cast<TH2D*>((*theHistoHelper->histolist())[52]);
  h_dx = static_cast<TH1D*>((*theHistoHelper->histolist())[53]);
  */
}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

ExN03SteppingAction::~ExN03SteppingAction()
{ }

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......

void ExN03SteppingAction::UserSteppingAction(const G4Step* aStep)
{
  G4Track* track = aStep->GetTrack();
  //  if(track->GetDynamicParticle()->GetDefinition()->GetParticleType()!="rhadron") track->SetTrackStatus(fKillTrackAndSecondaries);
  if(dynamic_cast<CustomParticle*>(track->GetDynamicParticle()->GetDefinition())==0) 
    {
      track->SetTrackStatus(fKillTrackAndSecondaries);
      return;
    }
  /*
  double Eold = theHistoHelper->GetKey("Estep");
  double Gold = theHistoHelper->GetKey("Gstep");
  double Xold = theHistoHelper->GetKey("Xstep");

  double Estep = track->GetDynamicParticle()->GetKineticEnergy();
  double Gstep = track->GetDynamicParticle()->GetTotalEnergy()/track->GetDynamicParticle()->GetDefinition()->GetPDGMass();
  double Xstep = track->GetPosition().x();

  theHistoHelper->SaveKey("Estep",Estep);
  theHistoHelper->SaveKey("Gstep",Gstep);
  theHistoHelper->SaveKey("Xstep",Xstep);

  double dx = (Xstep-Xold)/cm;
  double de = (Eold-Estep)/GeV;
  //  if(fabs(dx)>100.) std::cout<<"dx: "<<dx<<std::endl;

  if(fabs(dx)>1.e-4) h_dx->Fill(dx);
  //  if(fabs(dx)<0.1) std::cout<<"dx: "<<dx<<std::endl;
  
  double dedx = de/dx;

  //  if(dx>0.001 && dx < 1000) h_mfp->Fill(Eold,dx);

  if(dedx<1000. && dedx>0)
    {
      //      h_mfp->Fill(Eold,dx);

      h_dedx->Fill(Gold,dedx);
      h_dedx_scat->Fill(Gold,dedx);

      h_dedx_e->Fill(Eold/GeV,dedx);
      h_dedx_scat_e->Fill(Eold/GeV,dedx);

      double beta = 1.-1./(Gold*Gold);
      h_dedx_v->Fill(beta,dedx);
      h_dedx_scat_v->Fill(beta,dedx);

    }

  
  G4double stepl = 0.;
  if (track->GetDefinition()->GetPDGCharge() != 0.)
    stepl = aStep->GetStepLength();
  */

  return;

}

//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......



