#include "HistoHelper.hh"
#include<iostream>

HistoHelper* HistoHelper::GetInstance () 
{
  static HistoHelper inst;
  return &inst;
}

HistoHelper::HistoHelper() 
{ 
  phistos.push_back(new TProfile("mean_E-loss","Mean energy loss per interaction",100,0.,2000.));// 0
  phistos.push_back(new TProfile("mean_E-loss22","Mean energy loss per interaction",100,0.,2000.));// 1
  phistos.push_back(new TProfile("mean_E-loss23","Mean energy loss per interaction",100,0.,2000.));// 2
  phistos.push_back(new TProfile("mean_free_path","Mean free path vs. energy",20,0.,1000.));// 3
  phistos.push_back(new TH1D("penetration_depth","Penetration depth at fixed energy",100,0.,1000.));// 4
  phistos.push_back(new TProfile("penetration_depth_vs_energy","Penetration depth vs. energy",100,0.,1000.));// 5
  phistos.push_back(new TH1D("22count","2 -> 2 counter",100,0.,1000.));// 6
  phistos.push_back(new TH1D("23count","2 -> 3 counter",100,0.,1000.));// 7
  phistos.push_back(new TH1D("combcount","Combined counter",100,0.,1000.));// 8
  phistos.push_back(new TH2D("cos_theta22","Theta vs. E, 2 -> 2",100,-1.,1.,100,0.,1000.));// 9, Remember to calculate theta in units of pi
  phistos.push_back(new TH2D("cos_theta23","Theta vs. E, 2 -> 3",100,-1.,1.,100,0.,1000.));// 10, Remember to calculate theta in units of pi
  phistos.push_back(new TH2D("cos_thetacomb","Theta vs. E, combined",100,-1.,1.,100,0.,1000.));// 11, Remember to calculate theta in units of pi
  phistos.push_back(new TH2D("cos_theta_fullcms_22","Theta vs. E, 2 -> 2",100,-1.,1.,100,0.,1000.));// 12, OK, I think we remember now...
  phistos.push_back(new TH2D("cos_theta_fullcms_23","Theta vs. E, 2 -> 3",100,-1.,1.,100,0.,1000.));// 13
  phistos.push_back(new TH2D("cos_theta_fullcms_comb","Theta vs. E, combined",100,-1.,1.,100,0.,1000.));// 14
  phistos.push_back(new TH2D("cos_theta_cloudcms_22","Theta vs. E, 2 -> 2",100,-1.,1.,100,0.,1000.));// 15
  phistos.push_back(new TH2D("cos_theta_cloudcms_23","Theta vs. E, 2 -> 3",100,-1.,1.,100,0.,1000.));// 16
  phistos.push_back(new TH2D("cos_theta_cloudcms_comb","Theta vs. E, combined",100,-1.,1.,100,0.,1000.));// 17
  phistos.push_back(new TH1D("costheta1","cos(theta*), 2 -> 2, 0-100 GeV initial energy",100,-1.,1.));//18
  phistos.push_back(new TH1D("costheta2","cos(theta*), 2 -> 2, 100-500 GeV initial energy",100,-1.,1.));//19
  phistos.push_back(new TH1D("costheta3","cos(theta*), 2 -> 2, 500-1000 GeV initial energy",100,-1.,1.));//20
  phistos.push_back(new TH1D("costheta_lab","cos(theta_lab), 2 -> 2",100,-1.,1.));//21
  phistos.push_back(new TH1D("costheta_fullcms","cos(theta_fullcms), 2 -> 2",100,-1.,1.));//22
  phistos.push_back(new TH1D("costheta_cloudcms","cos(theta_cloudcms), 2 -> 2",100,-1.,1.));//23
  phistos.push_back(new TH1D("cloud_costheta_lab","cos(theta_lab), 2 -> 2",100,-1.,1.));//24
  phistos.push_back(new TH1D("cloud_costheta_fullcms","cos(theta_fullcms), 2 -> 2",100,-1.,1.));//25
  phistos.push_back(new TH1D("cloud_costheta_cloudcms","cos(theta_cloudcms), 2 -> 2",100,-1.,1.));//26
  phistos.push_back(new TH1D("pioncostheta","cos(theta), 2 -> 2",20,-1.,1.));//27
  phistos.push_back(new TH1D("cloud_lp_change","longitudinal percentual cloud momentum change (CMS), 2 -> 2",100,-1.,1.));//28
  phistos.push_back(new TH2D("E-loss_vs_E","Energy loss vs. energy",100,0.,2000.,100,0.,50.));//29
  phistos.push_back(new TH2D("E-loss_vs_E22","Energy loss vs. energy",100,0.,2000.,100,0.,50.));//30
  phistos.push_back(new TH2D("E-loss_vs_E23","Energy loss vs. energy",100,0.,2000.,100,0.,50.));//31
  phistos.push_back(new TProfile("psum_virt","Virtuality of momentum sum vs. energy",100,0.,2000.));//32
  phistos.push_back(new TH2D("psum_virt_scat","Virtuality of momentum sum vs. energy scatter",100,0.,2000.,100,0.,1000.));//33
  phistos.push_back(new TProfile("xsec_lab","Cross section per nucleon, lab frame",1000,0.,600.));//34
  phistos.push_back(new TH1D("sqrts","sqrt(s)",100,300,310.));//35
  phistos.push_back(new TProfile("xsec_cms","Cross section per nucleon, CMS",1000,302.,303.));//36
  phistos.push_back(new TProfile("E-loss_vs_gamma","Energy loss vs. gamma",100,1.,4.));//37
  phistos.push_back(new TH1D("n_int_per_event","Number of interactions per event",10,-0.5,9.5));//38
  phistos.push_back(new TH1D("x_int","Interaction x-position",120,-6.,6.));//39
  phistos.push_back(new TProfile("dEdx_EM_vs_gamma","dE/dx vs gamma",100,1.,4.));//40
  phistos.push_back(new TH2D("dEdx_EM_vs_gamma_2D","dE/dx vs gamma scatter",100,1.,4.,1000,0.,50.));//41
  phistos.push_back(new TH1D("flip_depth","Rmeson to baryon flip",100,0.,150.));//42

  double bins[101];
  std::cout<<"Marker"<<std::endl;
  for (int i = 0; i!=101; i++)
    {
      //      bins[i] = 10*pow(10.,i*0.02);
      bins[i] = 0.03*pow(10.,i*0.02)+1;
      //      std::cout<<bins[i]<<std::endl;
    }

  phistos.push_back(new TH1D("22countg","2 -> 2 counter vs. gamma",100,bins));// 43
  phistos.push_back(new TH1D("23countg","2 -> 3 counter vs gamma",100,bins));// 44
  phistos.push_back(new TH1D("combcountg","Combined counter vs gamma",100,bins));// 45
  phistos.push_back(new TProfile("E_loss_abs","Energy loss in 1m of iron",100,0.,1000.));//46

  phistos.push_back(new TProfile("psum_virt_g","Virtuality of momentum sum vs. gamma",100,1.,4.));//47
  phistos.push_back(new TH2D("psum_virt_scat_g","Virtuality of momentum sum vs. gamma scatter",100,1.,4.,100,0.,1000.));//48

  phistos.push_back(new TProfile("dEdx_EM_vs_E_kin","dE/dx vs kinetic energy",100,0.,2000.));//49
  phistos.push_back(new TH2D("dEdx_EM_vs_E_kin_2D","dE/dx vs kinetic energy scatter",100,0.,2000.,1000,0.,50.));//50
  phistos.push_back(new TProfile("dEdx_EM_vs_beta","dE/dx vs beta",100,0.,1.));//51
  phistos.push_back(new TH2D("dEdx_EM_vs_beta_2D","dE/dx vs beta scatter",100,0.,1.,1000,0.,50.));//52

  phistos.push_back(new TH1D("dx","dx",300,-10.,20.));//53

  phistos.push_back(new TProfile("dEdx_H_vs_gamma","dE/dx vs gamma",100,1.,4.));//54
  phistos.push_back(new TH2D("dEdx_H_vs_gamma_2D","dE/dx vs gamma scatter",100,1.,4.,1000,0.,50.));//55
  phistos.push_back(new TProfile("dEdx_H_vs_E_kin","dE/dx vs kinetic energy",100,0.,2000.));//56
  phistos.push_back(new TH2D("dEdx_H_vs_E_kin_2D","dE/dx vs kinetic energy scatter",100,0.,2000.,1000,0.,50.));//57
  phistos.push_back(new TProfile("dEdx_H_vs_beta","dE/dx vs beta",100,0.,1.));//58
  phistos.push_back(new TH2D("dEdx_H_vs_beta_2D","dE/dx vs beta scatter",100,0.,1.,1000,0.,50.));//59
  phistos.push_back(new TH2D("xy_pos","x and y pos of interaction",100,-2.,2.,100,-2.,2.));//60
  
}

HistoHelper::~HistoHelper()
{
  TFile histofile("HistoHelperFile.root","RECREATE","Root file created by HistoHelper");
  for (std::vector<TObject*>::iterator it = phistos.begin();it != phistos.end(); it++)
    {
      (*it)->Write();
    }
}

